## corrosion 0.4.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(Corrosion
    # Official releases will be major.minor.patch. When the `tweak` field is
    # set it indicates that we are on a commit, that is not a officially
    # tagged release. Users don't need to care about this, it is mainly to
    # clearly see in configure logs which version was used, without needing to
    # rely on `git`, since Corrosion may be installed or otherwise packaged.
    VERSION 0.4.7
    LANGUAGES NONE
    HOMEPAGE_URL "https://corrosion-rs.github.io/corrosion/"
)

# Default behavior:
# - If the project is being used as a subdirectory, then don't build tests and
#   don't enable any languages.
# - If this is a top level project, then build tests and enable the C++ compiler
if (NOT CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
    set(_CORROSION_TOP_LEVEL OFF)
else()
    set(_CORROSION_TOP_LEVEL ON)
endif()

# ==== Corrosion Configuration ====

option(
    CORROSION_DEV_MODE
    "Enables some additional features if you're developing Corrosion"
    ${_CORROSION_TOP_LEVEL}
)

option(
    CORROSION_BUILD_TESTS
    "Build Corrosion test project"
    ${_CORROSION_TOP_LEVEL}
)

set(
  CORROSION_GENERATOR_EXECUTABLE CACHE STRING
  "Use prebuilt, non-bootstrapped corrosion-generator")
mark_as_advanced(CORROSION_GENERATOR_EXECUTABLE)

if (CORROSION_GENERATOR_EXECUTABLE)
    add_executable(Corrosion::Generator IMPORTED GLOBAL)
    set_property(
        TARGET Corrosion::Generator
        PROPERTY IMPORTED_LOCATION ${CORROSION_GENERATOR_EXECUTABLE})
    set(CORROSION_INSTALL_EXECUTABLE_DEFAULT OFF)
elseif(CORROSION_NATIVE_TOOLING OR CMAKE_VERSION VERSION_LESS 3.19.0)
        set(CORROSION_INSTALL_EXECUTABLE_DEFAULT "ON")
else()
    set(CORROSION_INSTALL_EXECUTABLE_DEFAULT OFF)
endif()

option(
    CORROSION_INSTALL_EXECUTABLE
    "Controls whether corrosion-generator is installed with the package"
    ${CORROSION_INSTALL_EXECUTABLE_DEFAULT}
)
mark_as_advanced(CORROSION_INSTALL_EXECUTABLE)

if (_CORROSION_TOP_LEVEL)
    # We need to enable a language for corrosions test to work.
    # For projects using corrosion this is not needed
    enable_language(C)
endif()

# This little bit self-hosts the Corrosion toolchain to build the generator
# tool.
#
# It is strongly encouraged to install Corrosion separately and use
# `find_package(Corrosion REQUIRED)` instead if that works with your workflow.
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
include(Corrosion)

# Testing
if (CORROSION_BUILD_TESTS)
    include(CTest)
    add_subdirectory(test)
endif()

# If Corrosion is a subdirectory, do not enable its install code
if (NOT _CORROSION_TOP_LEVEL)
    return()
endif()

# Installation

include(GNUInstallDirs)

if(CORROSION_INSTALL_EXECUTABLE)
    get_property(
            _CORROSION_GENERATOR_EXE
            TARGET Corrosion::Generator PROPERTY IMPORTED_LOCATION
    )
    install(PROGRAMS "${_CORROSION_GENERATOR_EXE}" DESTINATION "${CMAKE_INSTALL_FULL_LIBEXECDIR}")
else()
    message(DEBUG "Not installing corrosion-generator since "
        "`CORROSION_INSTALL_EXECUTABLE` is set to ${CORROSION_INSTALL_EXECUTABLE}"
    )
endif()

# Generate the Config file
include(CMakePackageConfigHelpers)

configure_package_config_file(
    cmake/CorrosionConfig.cmake.in CorrosionConfig.cmake
    INSTALL_DESTINATION
        "${CMAKE_INSTALL_FULL_LIBDIR}/cmake/Corrosion"
)

write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/CorrosionConfigVersion.cmake"
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY
        SameMinorVersion # TODO: Should be SameMajorVersion when 1.0 is released
    ARCH_INDEPENDENT
)

install(
    FILES
        "${CMAKE_CURRENT_BINARY_DIR}/CorrosionConfig.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/CorrosionConfigVersion.cmake"
    DESTINATION
        "${CMAKE_INSTALL_FULL_LIBDIR}/cmake/Corrosion"
)

# These CMake scripts are needed both for the install and as a subdirectory
install(
    FILES
        cmake/Corrosion.cmake
        cmake/CorrosionGenerator.cmake
        cmake/FindRust.cmake
    DESTINATION
        "${CMAKE_INSTALL_FULL_DATADIR}/cmake"
)

=== generator/CMakeLists.txt ===
message(STATUS "Building CMake Generator for Corrosion - This may take a while")

set(generator_src "${CMAKE_CURRENT_BINARY_DIR}/legacy_generator_src")
set(generator_destination "${CMAKE_CURRENT_BINARY_DIR}/legacy_generator")
set(generator_build_quiet "")

file(MAKE_DIRECTORY "${generator_src}")
file(COPY src DESTINATION "${generator_src}")
if(Rust_VERSION VERSION_LESS "1.56")
    message(STATUS "Corrosion Generator: Using Compatibility lock file, due to rust version less than 1.56")
    file(COPY Compat.Cargo.lock Compat.Cargo.toml DESTINATION "${generator_src}")
    file(RENAME "${generator_src}/Compat.Cargo.lock" "${generator_src}/Cargo.lock")
    file(RENAME "${generator_src}/Compat.Cargo.toml" "${generator_src}/Cargo.toml")
else()
    file(COPY Cargo.lock Cargo.toml DESTINATION "${generator_src}")
endif()

# Using cargo install has the advantage of caching the build in the user .cargo directory,
# so likely the rebuild will be very cheap even after deleting the build directory.
execute_process(
        COMMAND ${CMAKE_COMMAND}
        -E env
        # If the Generator is built at configure of a project (instead of being pre-installed)
        # We don't want environment variables like `RUSTFLAGS` affecting the Generator build.
        --unset=RUSTFLAGS
        "CARGO_BUILD_RUSTC=${RUSTC_EXECUTABLE}"
        "${CARGO_EXECUTABLE}" install
        --path "."
        --root "${generator_destination}"
        --locked
        ${_CORROSION_QUIET_OUTPUT_FLAG}
        WORKING_DIRECTORY "${generator_src}"
        RESULT_VARIABLE generator_build_failed
)
if(generator_build_failed)
    message(FATAL_ERROR "Building CMake Generator for Corrosion - failed")
else()
    message(STATUS "Building CMake Generator for Corrosion - done")
endif()
set(host_executable_suffix "")
if(CMAKE_HOST_SYSTEM_NAME STREQUAL "Windows")
    set(host_executable_suffix ".exe")
endif()

set(_CORROSION_GENERATOR_EXE
        "${generator_destination}/bin/corrosion-generator${host_executable_suffix}"
)

add_executable(Corrosion::Generator IMPORTED GLOBAL)
set_property(
        TARGET Corrosion::Generator
        PROPERTY IMPORTED_LOCATION "${_CORROSION_GENERATOR_EXE}")

if (CORROSION_DEV_MODE)
    # If you're developing Corrosion, you want to make sure to re-configure whenever the
    # generator changes.
    file(GLOB_RECURSE _RUST_FILES CONFIGURE_DEPENDS generator/src/*.rs)
    file(GLOB _CARGO_FILES CONFIGURE_DEPENDS generator/Cargo.*)
    set_property(
            DIRECTORY APPEND
            PROPERTY CMAKE_CONFIGURE_DEPENDS
            ${_RUST_FILES} ${_CARGO_FILES})
endif()

=== test/crate_type/CMakeLists.txt ===
corrosion_tests_add_test(crate_type "cpp-exe")


set_tests_properties("crate_type_run_cpp-exe" PROPERTIES PASS_REGULAR_EXPRESSION
        "Hello from lib 1!\r?\nHello from lib 2!"
        )

=== test/find_rust/CMakeLists.txt ===
corrosion_tests_add_test(find_rust "")
corrosion_tests_add_test(rustup_proxy "")

=== test/nostd/CMakeLists.txt ===
corrosion_tests_add_test(nostd "")

=== test/output directory/CMakeLists.txt ===
if(CMAKE_VERSION VERSION_LESS 3.19.0)
    return()
endif()

if(CMAKE_C_COMPILER)
    set(TEST_C_COMPILER "C_COMPILER" "${CMAKE_C_COMPILER}")
endif()
if(CMAKE_CXX_COMPILER)
    set(TEST_CXX_COMPILER "CXX_COMPILER" "${CMAKE_CXX_COMPILER}")
endif()
if(CMAKE_GENERATOR_PLATFORM)
    set(TEST_GENERATOR_PLATFORM "GENERATOR_PLATFORM" "${CMAKE_GENERATOR_PLATFORM}")
endif()

add_test(NAME "output_directory_build"
    COMMAND
        ${CMAKE_COMMAND}
        -P "${CMAKE_SOURCE_DIR}/test/ConfigureAndBuild.cmake"
        SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/output directory"
        BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}/build"
        GENERATOR "${CMAKE_GENERATOR}"
        RUST_TOOLCHAIN "${Rust_TOOLCHAIN}"
        CARGO_TARGET "${Rust_CARGO_TARGET}"
        SYSTEM_NAME "${CMAKE_SYSTEM_NAME}"
        "${TEST_C_COMPILER}"
        "${TEST_CXX_COMPILER}"
        "${TEST_GENERATOR_PLATFORM}"

        COMMAND_EXPAND_LISTS
)
set_tests_properties("output_directory_build" PROPERTIES FIXTURES_SETUP "build_fixture_output_directory")
if(CORROSION_TESTS_INSTALL_CORROSION)
    set_tests_properties("output_directory_build" PROPERTIES FIXTURES_REQUIRED "fixture_corrosion_install")
endif()

foreach(output_approach targetprop var)
    if(output_approach STREQUAL "targetprop")
       set(rust_proj_suffix "1")
    elseif(output_approach STREQUAL "var")
        set(rust_proj_suffix "2")
    else()
        message(FATAL_ERROR "specify rust project suffix for new output approach ${output_approach}")
    endif()

    set(bin_name "rust_bin${rust_proj_suffix}${CMAKE_EXECUTABLE_SUFFIX}")

    add_test(NAME output_directory_bin_${output_approach}
            COMMAND
            "${CMAKE_COMMAND}"
            -P "${CMAKE_CURRENT_SOURCE_DIR}/TestFileExists.cmake"
            "${CMAKE_CURRENT_BINARY_DIR}/build/custom_bin_${output_approach}/${bin_name}"
    )
    set_tests_properties("output_directory_bin_${output_approach}" PROPERTIES FIXTURES_REQUIRED "build_fixture_output_directory")

    set(lib_name "rust_lib${rust_proj_suffix}")

    set(static_lib_name "${CMAKE_STATIC_LIBRARY_PREFIX}${lib_name}${CMAKE_STATIC_LIBRARY_SUFFIX}")

    add_test(NAME output_directory_staticlib_${output_approach}
            COMMAND
            "${CMAKE_COMMAND}"
            -P "${CMAKE_CURRENT_SOURCE_DIR}/TestFileExists.cmake"
            "${CMAKE_CURRENT_BINARY_DIR}/build/custom_archive_${output_approach}/${static_lib_name}"
    )
    set_tests_properties("output_directory_staticlib_${output_approach}" PROPERTIES FIXTURES_REQUIRED "build_fixture_output_directory")

    if(MINGW)
        # Windows-GNU defines "lib" as prefix for DLLs, but cargo creates foo.dll instead of libfoo.dll
        set(dynamic_lib_prefix "")
    else()
        set(dynamic_lib_prefix "${CMAKE_SHARED_LIBRARY_PREFIX}")
    endif()
    set(dynamic_lib_name "${dynamic_lib_prefix}${lib_name}${CMAKE_SHARED_LIBRARY_SUFFIX}")

    add_test(NAME output_directory_cdylib_${output_approach}
            COMMAND
            "${CMAKE_COMMAND}"
            -P "${CMAKE_CURRENT_SOURCE_DIR}/TestFileExists.cmake"
            "${CMAKE_CURRENT_BINARY_DIR}/build/custom_lib_${output_approach}/${dynamic_lib_name}"
    )
    set_tests_properties("output_directory_cdylib_${output_approach}" PROPERTIES FIXTURES_REQUIRED "build_fixture_output_directory")

    if(WIN32)
        set(implib_name ${CMAKE_IMPORT_LIBRARY_PREFIX}${lib_name}${CMAKE_IMPORT_LIBRARY_SUFFIX})

        add_test(NAME output_directory_implib_${output_approach}
            COMMAND
            "${CMAKE_COMMAND}"
            -P "${CMAKE_CURRENT_SOURCE_DIR}/TestFileExists.cmake"
            # Implib is an ARCHIVE artifact, see:
            # https://cmake.org/cmake/help/v3.25/manual/cmake-buildsystem.7.html#archive-output-artifacts
            "${CMAKE_CURRENT_BINARY_DIR}/build/custom_archive_${output_approach}/${implib_name}"
            )
        set_tests_properties("output_directory_implib_${output_approach}" PROPERTIES FIXTURES_REQUIRED "build_fixture_output_directory")

        if(MSVC)
            if(output_approach STREQUAL "targetprop")
                set(expected_lib_pdb_path "custom_lib_pdb_targetprop")
                set(expected_bin_pdb_path "custom_bin_pdb_targetprop")
            elseif(output_approach STREQUAL "var")
                # When using a CMAKE_ variable instead of a target property, both targets
                # end up in the same directory.
                set(expected_lib_pdb_path "custom_binlib_pdb_var")
                set(expected_bin_pdb_path "custom_binlib_pdb_var")
            else()
                message(FATAL_ERROR "specify rust project suffix for new output approach ${output_approach}")
            endif()

            set(lib_pdb_name "${lib_name}.pdb")
            add_test(NAME output_directory_cdylib_pdb_${output_approach}
                COMMAND
                "${CMAKE_COMMAND}"
                -P "${CMAKE_CURRENT_SOURCE_DIR}/TestFileExists.cmake"
                "${CMAKE_CURRENT_BINARY_DIR}/build/${expected_lib_pdb_path}/${lib_pdb_name}"
                )
            set_tests_properties("output_directory_cdylib_pdb_${output_approach}" PROPERTIES FIXTURES_REQUIRED "build_fixture_output_directory")

            set(bin_pdb_name "rust_bin${rust_proj_suffix}.pdb")
            add_test(NAME output_directory_bin_pdb_${output_approach}
                COMMAND
                "${CMAKE_COMMAND}"
                -P "${CMAKE_CURRENT_SOURCE_DIR}/TestFileExists.cmake"
                "${CMAKE_CURRENT_BINARY_DIR}/build/${expected_bin_pdb_path}/${bin_pdb_name}"
                )
            set_tests_properties("output_directory_bin_pdb_${output_approach}" PROPERTIES FIXTURES_REQUIRED "build_fixture_output_directory")
        endif()
    endif()

endforeach()

add_test(NAME postbuild_custom_command
    COMMAND
    "${CMAKE_COMMAND}"
    -P "${CMAKE_CURRENT_SOURCE_DIR}/TestFileExists.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/build/another_dir/moved_bin"
    )
set_tests_properties("postbuild_custom_command" PROPERTIES FIXTURES_REQUIRED "build_fixture_output_directory")

add_test(NAME "output_directory_cleanup" COMMAND "${CMAKE_COMMAND}" -E remove_directory "${CMAKE_CURRENT_BINARY_DIR}/build")
set_tests_properties("output_directory_cleanup" PROPERTIES FIXTURES_CLEANUP "build_fixture_output_directory")

=== test/cargo_flags/cargo_flags/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(test_project VERSION 0.1.0)
include(../../test_header.cmake)

corrosion_import_crate(MANIFEST_PATH rust/Cargo.toml FLAGS --features one)

add_executable(flags-exe main.cpp)
target_link_libraries(flags-exe PUBLIC flags-lib)
corrosion_set_cargo_flags(flags-lib --features two)
corrosion_set_cargo_flags(flags-lib $<TARGET_PROPERTY:flags-lib,more_flags>)

set_property(
    TARGET flags-lib
    APPEND
    PROPERTY more_flags --features three
)

=== test/cbindgen/rust2cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(test_project VERSION 0.1.0)
include(../../test_header.cmake)

corrosion_import_crate(MANIFEST_PATH rust/Cargo.toml)
corrosion_experimental_cbindgen(TARGET rust-lib HEADER_NAME "rust-lib.h")

add_executable(cpp-exe main.cpp)
set_property(TARGET cpp-exe PROPERTY CXX_STANDARD 11)
target_link_libraries(cpp-exe PUBLIC rust-lib)

=== test/custom_profiles/basic_profiles/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(test_project VERSION 0.1.0)
include(../../test_header.cmake)

if(NOT DEFINED CARGO_PROFILE)
    message(FATAL_ERROR "Test internal error. The test should be called with the CARGO_PROFILE parameter.")
endif()

corrosion_import_crate(MANIFEST_PATH rust/Cargo.toml PROFILE ${CARGO_PROFILE})

add_executable(${CARGO_PROFILE}_bin main.cpp)
target_link_libraries(${CARGO_PROFILE}_bin PUBLIC cargo-profiles-lib)

=== test/custom_profiles/custom_profiles/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(test_project VERSION 0.1.0)
include(../../test_header.cmake)

set(_release_profile $<IF:$<CONFIG:Release>,release-without-dbg,custom-without-dbg>)
set(custom_profile $<IF:$<CONFIG:Debug>,dev-without-dbg,${_release_profile}>)

if(CORROSION_TEST_USE_TARGET_SPECIFIC_OVERRIDE)
    # Select "wrong" profile here on purpose.
    corrosion_import_crate(MANIFEST_PATH rust/Cargo.toml PROFILE dev)
    set_target_properties(custom-profiles-lib
        PROPERTIES
        INTERFACE_CORROSION_CARGO_PROFILE "${custom_profile}"
    )
else()
    corrosion_import_crate(MANIFEST_PATH rust/Cargo.toml PROFILE ${custom_profile})
endif()

add_executable(custom-profile-exe main.cpp)
target_link_libraries(custom-profile-exe PUBLIC custom-profiles-lib)

=== test/cxxbridge/cxxbridge_rust2cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(test_project VERSION 0.1.0)
include(../../test_header.cmake)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED 1)

corrosion_import_crate(MANIFEST_PATH rust/Cargo.toml)
corrosion_add_cxxbridge(cxxbridge-cpp CRATE cxxbridge-crate MANIFEST_PATH rust FILES lib.rs foo/mod.rs)

add_executable(cxxbridge-exe main.cpp)
target_link_libraries(cxxbridge-exe PUBLIC cxxbridge-cpp)

if(MSVC)
    # Note: This is required because we use `cxx` which uses `cc` to compile and link C++ code.
    corrosion_set_env_vars(cxxbridge-crate "CFLAGS=-MDd" "CXXFLAGS=-MDd")
endif()

=== test/envvar/envvar/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(test_project VERSION 0.1.0)
include(../../test_header.cmake)

corrosion_import_crate(MANIFEST_PATH Cargo.toml)

corrosion_set_env_vars(rust-lib-requiring-envvar
        "ANOTHER_VARIABLE=ANOTHER_VALUE"
        "$<TARGET_PROPERTY:program_requiring_rust_lib_with_envvar,INDIRECT_VAR_TEST>"
        "COR_CARGO_VERSION_MAJOR=${Rust_CARGO_VERSION_MAJOR}"
        "COR_CARGO_VERSION_MINOR=${Rust_CARGO_VERSION_MINOR}"
)

add_executable(program_requiring_rust_lib_with_envvar main.cpp)

set_property(
    TARGET program_requiring_rust_lib_with_envvar
    APPEND
    PROPERTY INDIRECT_VAR_TEST
    "REQUIRED_VARIABLE=EXPECTED_VALUE"
)

target_link_libraries(program_requiring_rust_lib_with_envvar PUBLIC rust-lib-requiring-envvar)

=== debian/changelog ===
corrosion (0.4.7-1) unstable; urgency=medium

  * Initial release (Closes: #1063612)

 -- Nilesh Patra <nilesh@debian.org>  Sun, 11 Feb 2024 02:36:29 +0530

=== debian/control ===
Source: corrosion
Maintainer: Nilesh Patra <nilesh@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               cargo,
               rustc,
               cbindgen <!nocheck>
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debian/corrosion
Vcs-Git: https://salsa.debian.org/debian/corrosion.git
Homepage: https://corrosion-rs.github.io/corrosion/
Rules-Requires-Root: no

Package: corrosion
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Tool for integrating rust with an existing CMake project
 Corrosion, formerly known as cmake-cargo, is a tool for integrating Rust
 into an existing CMake project.
 .
 Corrosion can automatically import executables, static libraries,
 and dynamic libraries from a workspace or package manifest
 (Cargo.toml file).

=== debian/tests/control ===
Tests: run-unit-test
Depends: @,
         quilt,
         cmake,
         rustc,
         cargo,
         cbindgen,
         build-essential,
Restrictions: allow-stderr

## corrosion 0.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
     # tagged release. Users don't need to care about this, it is mainly to
     # clearly see in configure logs which version was used, without needing to
     # rely on `git`, since Corrosion may be installed or otherwise packaged.
-    VERSION 0.4.7
+    VERSION 0.5.0
     LANGUAGES NONE
     HOMEPAGE_URL "https://corrosion-rs.github.io/corrosion/"
 )

=== test/envvar/CMakeLists.txt ===
corrosion_tests_add_test(envvar "program_requiring_rust_lib_with_envvar")

set_tests_properties("envvar_run_program_requiring_rust_lib_with_envvar" PROPERTIES PASS_REGULAR_EXPRESSION
        "Ok"
        )

=== test/gensource/CMakeLists.txt ===
corrosion_tests_add_test(gensource "")

#set_tests_properties("features_run_features-cpp-exe" PROPERTIES PASS_REGULAR_EXPRESSION
#        "Hello, Cpp! I'm Rust!\r?\nHello, Cpp again! I'm Rust again!\r?\nHello, Cpp again! I'm Rust again, third time the charm!"
#        )

=== test/cargo_flags/cargo_flags/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(test_project VERSION 0.1.0)
include(../../test_header.cmake)

corrosion_import_crate(MANIFEST_PATH rust/Cargo.toml FLAGS --features one)

add_executable(flags-exe main.cpp)
target_link_libraries(flags-exe PUBLIC flags_lib)
corrosion_set_cargo_flags(flags_lib --features two)
corrosion_set_cargo_flags(flags_lib $<TARGET_PROPERTY:flags_lib,more_flags>)

set_property(
    TARGET flags_lib
    APPEND
    PROPERTY more_flags --features three
)

=== test/crate_type/crate_type/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(test_project VERSION 0.1.0)
include(../../test_header.cmake)

# Add --crate-type to ensure that only the specified type of library is built and no error is thrown
corrosion_import_crate(MANIFEST_PATH proj1/Cargo.toml CRATE_TYPES staticlib FLAGS --crate-type=staticlib)
corrosion_import_crate(MANIFEST_PATH proj2/Cargo.toml CRATE_TYPES cdylib FLAGS --crate-type=cdylib)

add_executable(cpp-exe main.cpp)
target_link_libraries(cpp-exe proj1)
target_link_libraries(cpp-exe proj2)

=== test/custom_profiles/basic_profiles/CMakeLists.txt ===
--- 
+++ 
@@ -9,4 +9,4 @@
 corrosion_import_crate(MANIFEST_PATH rust/Cargo.toml PROFILE ${CARGO_PROFILE})
 
 add_executable(${CARGO_PROFILE}_bin main.cpp)
-target_link_libraries(${CARGO_PROFILE}_bin PUBLIC cargo-profiles-lib)
+target_link_libraries(${CARGO_PROFILE}_bin PUBLIC cargo_profiles_lib)

=== test/custom_profiles/custom_profiles/CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 if(CORROSION_TEST_USE_TARGET_SPECIFIC_OVERRIDE)
     # Select "wrong" profile here on purpose.
     corrosion_import_crate(MANIFEST_PATH rust/Cargo.toml PROFILE dev)
-    set_target_properties(custom-profiles-lib
+    set_target_properties(custom_profiles_lib
         PROPERTIES
         INTERFACE_CORROSION_CARGO_PROFILE "${custom_profile}"
     )
@@ -17,4 +17,4 @@
 endif()
 
 add_executable(custom-profile-exe main.cpp)
-target_link_libraries(custom-profile-exe PUBLIC custom-profiles-lib)
+target_link_libraries(custom-profile-exe PUBLIC custom_profiles_lib)

=== test/features/features/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(test_project VERSION 0.1.0)
include(../../test_header.cmake)

corrosion_import_crate(MANIFEST_PATH rust/Cargo.toml FEATURES thirdfeature ALL_FEATURES)

add_executable(features-cpp-exe main.cpp)
target_link_libraries(features-cpp-exe PUBLIC rust_feature_lib)

corrosion_set_features(rust_feature_lib
        ALL_FEATURES OFF
        NO_DEFAULT_FEATURES
        FEATURES
            $<TARGET_PROPERTY:features-cpp-exe,app_features>
)

set_property(
    TARGET features-cpp-exe
    APPEND
    PROPERTY app_features myfeature
)
set_property(
    TARGET features-cpp-exe
    APPEND
    PROPERTY app_features secondfeature
)

=== test/nostd/nostd/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(test_project VERSION 0.1.0)
include(../../test_header.cmake)

corrosion_import_crate(MANIFEST_PATH rust/Cargo.toml NO_STD)

set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -nostdlib")
list(REMOVE_ITEM CMAKE_CXX_IMPLICIT_LINK_LIBRARIES stdc++)

add_library(nostd-cpp-lib STATIC main.cpp)
target_link_libraries(nostd-cpp-lib PUBLIC rust-nostd-lib)

=== test/output directory/output directory/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(test_project VERSION 0.1.0)
include(../../test_header.cmake)

corrosion_import_crate(MANIFEST_PATH proj1/Cargo.toml)

# Note: The output directories defined here must be manually kept in sync with the expected test location.
set_target_properties(rust_bin1
    PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/custom_bin_targetprop"
        PDB_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/custom_bin_pdb_targetprop"

)
set_target_properties(rust_lib1 PROPERTIES ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/custom_archive_targetprop")
set_target_properties(rust_lib1
    PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/custom_lib_targetprop"
        PDB_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/custom_lib_pdb_targetprop"
)

add_custom_command(TARGET cargo-build_rust_bin1 POST_BUILD
    COMMAND
    ${CMAKE_COMMAND} -E make_directory "${CMAKE_CURRENT_BINARY_DIR}/another_dir"
    COMMAND
    ${CMAKE_COMMAND} -E copy_if_different "$<TARGET_PROPERTY:rust_bin1,LOCATION>" "${CMAKE_CURRENT_BINARY_DIR}/another_dir/moved_bin"
    )

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/custom_bin_var")
set(CMAKE_PDB_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/custom_binlib_pdb_var")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/custom_archive_var")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/custom_lib_var")

corrosion_import_crate(MANIFEST_PATH proj2/Cargo.toml)

unset(CMAKE_RUNTIME_OUTPUT_DIRECTORY)
unset(CMAKE_PDB_OUTPUT_DIRECTORY)
unset(CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
unset(CMAKE_LIBRARY_OUTPUT_DIRECTORY)
unset(CMAKE_PDB_OUTPUT_DIRECTORY)

add_executable(consumer consumer.cpp)
add_dependencies(consumer cargo-build_rust_lib1 cargo-build_rust_lib2)

target_link_libraries(consumer rust_lib1 rust_lib2)

=== test/parse_target_triple/parse_target_triple_should_fail/CMakeLists.txt ===
# This test is supposed to ensure that the regex in _corrosion_parse_platform works as expected.
cmake_minimum_required(VERSION 3.15)
project(test_project VERSION 0.1.0)
include(../../test_header.cmake)

_corrosion_parse_target_triple("x86_64-unknown-linux-gnu-toomuch" arch vendor os env)

=== test/rust2cpp/rust2cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(test_project VERSION 0.1.0)
include(../../test_header.cmake)

corrosion_import_crate(MANIFEST_PATH rust/Cargo.toml)

add_executable(cpp-exe main.cpp)
target_link_libraries(cpp-exe PUBLIC rust_lib)

add_executable(cpp-exe-shared main.cpp)
target_link_libraries(cpp-exe-shared
        PUBLIC rust_lib-shared)

=== debian/changelog ===
corrosion (0.5.0-1ubuntu1) plucky; urgency=medium

  * Skip the cargo_config_rustflags_build test for now.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Thu, 06 Mar 2025 00:10:14 -0600

corrosion (0.5.0-1) unstable; urgency=medium

  * New upstream version 0.5.0
  * Bump Standards-Version to 4.7.0 (no changes needed)

 -- Nilesh Patra <nilesh@debian.org>  Tue, 02 Jul 2024 19:37:04 +0530

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: corrosion
-Maintainer: Nilesh Patra <nilesh@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Nilesh Patra <nilesh@debian.org>
 Section: devel
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
@@ -7,7 +8,7 @@
                cargo,
                rustc,
                cbindgen <!nocheck>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/debian/corrosion
 Vcs-Git: https://salsa.debian.org/debian/corrosion.git
 Homepage: https://corrosion-rs.github.io/corrosion/

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
   https://github.com/corrosion-rs/corrosion/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## corrosion 0.5.2

=== test/cbindgen/CMakeLists.txt ===
corrosion_tests_add_test(cbindgen_rust2cpp "cpp-exe" TEST_SRC_DIR rust2cpp)

set_tests_properties(cbindgen_rust2cpp_run_cpp-exe PROPERTIES PASS_REGULAR_EXPRESSION
        "^add_point Result: Point { x: 100, y: 100 }\r?\n$"
)
# Todo: We also should add a cpp2rust test with the following setup:
# - A rust lib that is used by a rust executable
# - cbindgen creates bindings for the rust-lib
# - c++ code uses the rust lib and is used in turn by the rust bin.

=== test/external_corrosion_generator/CMakeLists.txt ===
if(CORROSION_TESTS_INSTALL_CORROSION)
    add_test(NAME "ExternalCorrosionGenerator"
            COMMAND
            ${CMAKE_COMMAND}
            -P "${CMAKE_SOURCE_DIR}/test/ConfigureAndBuild.cmake"
            SOURCE_DIR "${CMAKE_CURRENT_LIST_DIR}/ExternalCorrosionGenerator"
            BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}/build"
            GENERATOR "${CMAKE_GENERATOR}"
            RUST_TOOLCHAIN "${Rust_TOOLCHAIN}"
            EXTERNAL_CORROSION_GENERATOR "${test_install_path}/libexec/corrosion-generator"
            COMMAND_EXPAND_LISTS
            )
    set_tests_properties("ExternalCorrosionGenerator" PROPERTIES FIXTURES_REQUIRED "fixture_corrosion_install")
endif()

=== test/features/CMakeLists.txt ===
corrosion_tests_add_test(features "features-cpp-exe")

set_tests_properties("features_run_features-cpp-exe" PROPERTIES PASS_REGULAR_EXPRESSION
        "Hello, Cpp! I'm Rust!\r?\nHello, Cpp again! I'm Rust again!\r?\nHello, Cpp again! I'm Rust again, third time the charm!"
        )

=== test/hostbuild/CMakeLists.txt ===
# FIXME: ONly test this when cross-compiling?
corrosion_tests_add_test(hostbuild "rust-host-program")

set_tests_properties("hostbuild_run_rust-host-program" PROPERTIES PASS_REGULAR_EXPRESSION
        "^ok\r?\nHello Rust Hostbuild, I am an external C function"
        )
# Run tests are disabled by default when cross-compiling, however we still want to test hostbuild!
# So we manually re-enable the test here.
if(CMAKE_CROSSCOMPILING)
    set_tests_properties("hostbuild_run_rust-host-program" PROPERTIES DISABLED FALSE)
endif()

=== test/parse_target_triple/CMakeLists.txt ===
corrosion_tests_add_test(parse_target_triple "")
corrosion_tests_add_test(parse_target_triple_should_fail "")

set_tests_properties("parse_target_triple_build" PROPERTIES FAIL_REGULAR_EXPRESSION
        "CMake Warning"
        )

set_tests_properties("parse_target_triple_should_fail_build" PROPERTIES PASS_REGULAR_EXPRESSION
    "CMake Warning"
    )

=== test/workspace/CMakeLists.txt ===
corrosion_tests_add_test(workspace "my_program")

set_tests_properties("workspace_run_my_program" PROPERTIES PASS_REGULAR_EXPRESSION
        "^Ok\r?\n$"
        )

=== test/cpp2rust/cpp2rust/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(test_project VERSION 0.1.0)
include(../../test_header.cmake)

corrosion_import_crate(MANIFEST_PATH rust/Cargo.toml)

add_library(cpp-lib lib.cpp)
target_compile_features(cpp-lib PRIVATE cxx_std_14)
set_target_properties(
    cpp-lib
    PROPERTIES
        POSITION_INDEPENDENT_CODE ON
)

add_library(cpp-lib2 lib2.cpp)
target_compile_features(cpp-lib2 PRIVATE cxx_std_14)
set_target_properties(
        cpp-lib2
        PROPERTIES
        POSITION_INDEPENDENT_CODE ON
        OUTPUT_NAME cpp-lib-renamed
)

add_library(cpp-lib3 "path with space/lib3.cpp" )
target_compile_features(cpp-lib3 PRIVATE cxx_std_14)
set_target_properties(
        cpp-lib3
        PROPERTIES
        POSITION_INDEPENDENT_CODE ON
)

corrosion_link_libraries(rust-exe cpp-lib cpp-lib2 cpp-lib3)

=== test/cxxbridge/cxxbridge_rust2cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(test_project VERSION 0.1.0)
include(../../test_header.cmake)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED 1)

corrosion_import_crate(MANIFEST_PATH rust/Cargo.toml)
corrosion_add_cxxbridge(cxxbridge-cpp CRATE cxxbridge_crate MANIFEST_PATH rust FILES lib.rs foo/mod.rs)

add_executable(cxxbridge-exe main.cpp)
target_link_libraries(cxxbridge-exe PUBLIC cxxbridge-cpp)

if(MSVC)
    # Note: This is required because we use `cxx` which uses `cc` to compile and link C++ code.
    corrosion_set_env_vars(cxxbridge_crate "CFLAGS=-MDd" "CXXFLAGS=-MDd")
endif()

=== test/envvar/envvar/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 corrosion_import_crate(MANIFEST_PATH Cargo.toml)
 
-corrosion_set_env_vars(rust-lib-requiring-envvar
+corrosion_set_env_vars(rust_lib_requiring_envvar
         "ANOTHER_VARIABLE=ANOTHER_VALUE"
         "$<TARGET_PROPERTY:program_requiring_rust_lib_with_envvar,INDIRECT_VAR_TEST>"
         "COR_CARGO_VERSION_MAJOR=${Rust_CARGO_VERSION_MAJOR}"
@@ -20,4 +20,4 @@
     "REQUIRED_VARIABLE=EXPECTED_VALUE"
 )
 
-target_link_libraries(program_requiring_rust_lib_with_envvar PUBLIC rust-lib-requiring-envvar)
+target_link_libraries(program_requiring_rust_lib_with_envvar PUBLIC rust_lib_requiring_envvar)

=== test/hostbuild/hostbuild/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(test_project VERSION 0.1.0)
include(../../test_header.cmake)

corrosion_import_crate(MANIFEST_PATH ${CMAKE_CURRENT_SOURCE_DIR}/Cargo.toml)

corrosion_set_hostbuild(rust-host-program)

=== test/output directory/output directory/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(test_project VERSION 0.1.0)
include(../../test_header.cmake)

if(NOT CORROSION_NATIVE_TOOLING)
    corrosion_import_crate(MANIFEST_PATH proj1/Cargo.toml)

    # Note: The output directories defined here must be manually kept in sync with the expected test location.
    set_target_properties(rust_bin1
        PROPERTIES
            RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/custom_bin_targetprop"
            PDB_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/custom_bin_pdb_targetprop"

    )
    set_target_properties(rust_lib1 PROPERTIES ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/custom_archive_targetprop")
    set_target_properties(rust_lib1
        PROPERTIES
            LIBRARY_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/custom_lib_targetprop"
            PDB_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/custom_lib_pdb_targetprop"
    )

    add_custom_command(TARGET cargo-build_rust_bin1 POST_BUILD
        COMMAND
        ${CMAKE_COMMAND} -E make_directory "${CMAKE_CURRENT_BINARY_DIR}/another_dir"
        COMMAND
        ${CMAKE_COMMAND} -E copy_if_different
                       "$<TARGET_PROPERTY:rust_bin1,LOCATION>"
                       "${CMAKE_CURRENT_BINARY_DIR}/another_dir/moved_bin"
        )
endif()
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/custom_bin_var")
set(CMAKE_PDB_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/custom_binlib_pdb_var")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/custom_archive_var")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/custom_lib_var")

corrosion_import_crate(MANIFEST_PATH proj2/Cargo.toml)

unset(CMAKE_RUNTIME_OUTPUT_DIRECTORY)
unset(CMAKE_PDB_OUTPUT_DIRECTORY)
unset(CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
unset(CMAKE_LIBRARY_OUTPUT_DIRECTORY)
unset(CMAKE_PDB_OUTPUT_DIRECTORY)

add_executable(consumer consumer.cpp)
add_dependencies(consumer cargo-build_rust_lib2)

target_link_libraries(consumer rust_lib2)

=== test/parse_target_triple/parse_target_triple/CMakeLists.txt ===
# This test is supposed to ensure that the regex in _corrosion_parse_platform works as expected.
cmake_minimum_required(VERSION 3.15)
project(test_project VERSION 0.1.0)
include(../../test_header.cmake)

# Todo: Test if the output matches expectations.
_corrosion_parse_target_triple("../../blah/x86_64-unknown-custom-gnu.json" arch vendor os env)
_corrosion_parse_target_triple("x86_64-unknown-custom-gnu.json" arch vendor os env)
_corrosion_parse_target_triple("/path/to/x86_64-unknown-custom-musl.json" arch vendor os env)
_corrosion_parse_target_triple("../../blah/x86_64-custom_os.json" arch vendor os env)

# List of builtin targets aquired via `rustup target list` with rust 1.64 on Linux.
set(rustup_shipped_targets
        "aarch64-apple-darwin"
        "aarch64-apple-ios"
        "aarch64-apple-ios-sim"
        "aarch64-fuchsia"
        "aarch64-linux-android"
        "aarch64-pc-windows-msvc"
        "aarch64-unknown-linux-gnu"
        "aarch64-unknown-linux-musl"
        "aarch64-unknown-none"
        "aarch64-unknown-none-softfloat"
        "arm-linux-androideabi"
        "arm-unknown-linux-gnueabi"
        "arm-unknown-linux-gnueabihf"
        "arm-unknown-linux-musleabi"
        "arm-unknown-linux-musleabihf"
        "armebv7r-none-eabi"
        "armebv7r-none-eabihf"
        "armv5te-unknown-linux-gnueabi"
        "armv5te-unknown-linux-musleabi"
        "armv7-linux-androideabi"
        "armv7-unknown-linux-gnueabi"
        "armv7-unknown-linux-gnueabihf"
        "armv7-unknown-linux-musleabi"
        "armv7-unknown-linux-musleabihf"
        "armv7a-none-eabi"
        "armv7r-none-eabi"
        "armv7r-none-eabihf"
        "asmjs-unknown-emscripten"
        "i586-pc-windows-msvc"
        "i586-unknown-linux-gnu"
        "i586-unknown-linux-musl"
        "i686-linux-android"
        "i686-pc-windows-gnu"
        "i686-pc-windows-msvc"
        "i686-unknown-freebsd"
        "i686-unknown-linux-gnu"
        "i686-unknown-linux-musl"
        "mips-unknown-linux-gnu"
        "mips-unknown-linux-musl"
        "mips64-unknown-linux-gnuabi64"
        "mips64-unknown-linux-muslabi64"
        "mips64el-unknown-linux-gnuabi64"
        "mips64el-unknown-linux-muslabi64"
        "mipsel-unknown-linux-gnu"
        "mipsel-unknown-linux-musl"
        "nvptx64-nvidia-cuda"
        "powerpc-unknown-linux-gnu"
        "powerpc64-unknown-linux-gnu"
        "powerpc64le-unknown-linux-gnu"
        "riscv32i-unknown-none-elf"
        "riscv32imac-unknown-none-elf"
        "riscv32imc-unknown-none-elf"
        "riscv64gc-unknown-linux-gnu"
        "riscv64gc-unknown-none-elf"
        "riscv64imac-unknown-none-elf"
        "s390x-unknown-linux-gnu"
        "sparc64-unknown-linux-gnu"
        "sparcv9-sun-solaris"
        "thumbv6m-none-eabi"
        "thumbv7em-none-eabi"
        "thumbv7em-none-eabihf"
        "thumbv7m-none-eabi"
        "thumbv7neon-linux-androideabi"
        "thumbv7neon-unknown-linux-gnueabihf"
        "thumbv8m.base-none-eabi"
        "thumbv8m.main-none-eabi"
        "thumbv8m.main-none-eabihf"
        "wasm32-unknown-emscripten"
        "wasm32-unknown-unknown"
        "wasm32-wasi"
        "x86_64-apple-darwin"
        "x86_64-apple-ios"
        "x86_64-fortanix-unknown-sgx"
        "x86_64-fuchsia"
        "x86_64-linux-android"
        "x86_64-pc-solaris"
        "x86_64-pc-windows-gnu"
        "x86_64-pc-windows-msvc"
        "x86_64-sun-solaris"
        "x86_64-unknown-freebsd"
        "x86_64-unknown-illumos"
        "x86_64-unknown-linux-gnu"
        "x86_64-unknown-linux-gnux32"
        "x86_64-unknown-linux-musl"
        "x86_64-unknown-netbsd"
        "x86_64-unknown-none"
        "x86_64-unknown-redox"
)
set(other_targets riscv32imc-esp-espidf xtensa-esp32s3-none-elf)

foreach(target ${rustup_shipped_targets} ${other_targets})
    _corrosion_parse_target_triple("${target}"  arch vendor os env)
endforeach()

=== debian/changelog ===
corrosion (0.5.2-4) unstable; urgency=medium

  * QA upload.
  * Apply Multi-Arch: hint
  * Disable useless Salsa CI jobs
  * Bump Standards-Version to 4.7.3, no change needed
  * autopkgtest do not need "quilt"

 -- Alexandre Detiste <tchet@debian.org>  Fri, 27 Feb 2026 16:45:13 +0100

corrosion (0.5.2-3) unstable; urgency=medium

  * QA upload.
  * Fix clean target.
  * d/control: Drop "Priority: optional" (default).

 -- Santiago Vila <sanvila@debian.org>  Wed, 17 Dec 2025 16:15:00 +0100

corrosion (0.5.2-2) unstable; urgency=medium

  * Team Upload.
  * Drop Redundant "Rules-Requires-Root: no"
  * Move d/watch to version 5
  * Remove myself from maintainer; Add Debian QA Group

 -- Nilesh Patra <nilesh@debian.org>  Sun, 02 Nov 2025 15:54:18 +0530

corrosion (0.5.2-1) unstable; urgency=medium

  * New upstream version 0.5.2
  * Bump Standards-Version to 4.7.2 (no changes needed)

 -- Nilesh Patra <nilesh@debian.org>  Wed, 13 Aug 2025 21:14:51 +0530

=== debian/control ===
Source: corrosion
Maintainer: Debian QA Group <packages@qa.debian.org>
Section: devel
Build-Depends:
 debhelper-compat (= 13),
 cargo,
 cbindgen <!nocheck>,
 cmake,
 rustc,
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/debian/corrosion
Vcs-Git: https://salsa.debian.org/debian/corrosion.git
Homepage: https://corrosion-rs.github.io/corrosion/

Package: corrosion
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Tool for integrating rust with an existing CMake project
 Corrosion, formerly known as cmake-cargo, is a tool for integrating Rust
 into an existing CMake project.
 .
 Corrosion can automatically import executables, static libraries,
 and dynamic libraries from a workspace or package manifest
 (Cargo.toml file).

=== debian/tests/control ===
Tests:
 run-unit-test,
Depends:
 build-essential,
 cargo,
 cbindgen,
 cmake,
 rustc,
 @,
Restrictions:
 allow-stderr,
